## mingw-w64-helics-3.5.2-1.src.tar.zst

=== CMakeLists.txt ===
# ~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~

cmake_minimum_required(VERSION 3.11...3.28)

# Install dependencies using vcpkg if VCPKG_ROOT is set and no CMake Toolchain file is given vcpkg
# installation on a system doesn't set VCPKG_ROOT, so setting it should be like an opt-in for users
option(HELICS_DISABLE_VCPKG "Force CMake to ignore VCPKG_ROOT even if it is set" OFF)
mark_as_advanced(HELICS_DISABLE_VCPKG)
if(DEFINED ENV{VCPKG_ROOT} AND NOT DEFINED CMAKE_TOOLCHAIN_FILE AND NOT HELICS_DISABLE_VCPKG)
    set(CMAKE_TOOLCHAIN_FILE "$ENV{VCPKG_ROOT}/scripts/buildsystems/vcpkg.cmake" CACHE STRING "")
endif()

project(HELICS VERSION 3.5.2)

# -----------------------------------------------------------------------------
# HELICS Version number
# -----------------------------------------------------------------------------
set(HELICS_VERSION_BUILD)
# use ISO date YYYY-MM-DD
set(HELICS_DATE "2024-04-08")

set(HELICS_VERSION_UNDERSCORE
    "${HELICS_VERSION_MAJOR}_${HELICS_VERSION_MINOR}_${HELICS_VERSION_PATCH}"
)
if(HELICS_VERSION_BUILD)
    set(HELICS_VERSION "${HELICS_VERSION}-${HELICS_VERSION_BUILD}")
    set(HELICS_VERSION_UNDERSCORE "${HELICS_VERSION_UNDERSCORE}-${HELICS_VERSION_BUILD}")
endif()

set(HELICS_COMPILER_VERSION
    "${CMAKE_GENERATOR} ${CMAKE_GENERATOR_PLATFORM} ${CMAKE_SYSTEM}:${CMAKE_CXX_COMPILER_ID}-${CMAKE_CXX_COMPILER_VERSION}"
)
message(STATUS "SYSTEM INFO -> ${HELICS_COMPILER_VERSION}")

# -----------------------------------------------------------------------------
# set the module path and include some common macros
# -----------------------------------------------------------------------------

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/config/cmake/"
                          "${PROJECT_SOURCE_DIR}/ThirdParty/cmake/"
    )
else()
    set(${PROJECT_NAME}_ORIGINAL_MODULE_PATH ${CMAKE_MODULE_PATH})
    set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/config/cmake/"
                          "${PROJECT_SOURCE_DIR}/ThirdParty/cmake/" ${CMAKE_MODULE_PATH}
    )

endif()

include(commonBuildPaths)

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    set_property(GLOBAL PROPERTY USE_FOLDERS ON)
else()
    get_property(helics-use-folders GLOBAL PROPERTY USE_FOLDERS)
endif()

if(NOT HELICS_DISABLE_GIT_OPERATIONS)
    # generate a version description based on git tags
    include(version_describe)
    git_version_describe(${HELICS_SOURCE_DIR} HELICS_VERSION_DESCRIPTION)
endif()

if(HELICS_VERSION_DESCRIPTION)
    message(STATUS "helics version tag description is ${HELICS_VERSION_DESCRIPTION}")
    string(TIMESTAMP current_date "%Y-%m-%d")
    set(HELICS_VERSION_STRING "${HELICS_VERSION}-${HELICS_VERSION_DESCRIPTION} (${current_date})")
else()
    set(HELICS_VERSION_STRING "${HELICS_VERSION} (${HELICS_DATE})")
endif()

include(extraMacros)
include(CMakeDependentOption)
include(copy_key_files)
include(CTest)

if(NOT CMAKE_VERSION VERSION_LESS 3.12)
    option(
        HELICS_ENABLE_PYTHON_BUILD_SCRIPTS
        "HELICS build systems can use python to automatically generate some files.  This is not required but may be useful if you are a developer and frequently modifying some files"
        OFF
    )
    mark_as_advanced(HELICS_ENABLE_PYTHON_BUILD_SCRIPTS)

    if(HELICS_ENABLE_PYTHON_BUILD_SCRIPTS)
        find_package(Python COMPONENTS Interpreter)
    endif()
endif()

# allow BOOST library inclusion to be turned off completely; this option will disable the IPC core
option(HELICS_DISABLE_BOOST OFF "disable all references to the Boost C++ libraries")
mark_as_advanced(HELICS_DISABLE_BOOST)

# allow ASIO library inclusion to be turned off completely; this option will disable the UDP and TCP
# core as well as the timeout detection and real-time features of HELICS
option(HELICS_DISABLE_ASIO OFF "disable all references to the ASIO C++ libraries")
mark_as_advanced(HELICS_DISABLE_ASIO)

# we want to acknowledge this flag since it is standard CMake but it can cause issues in submodules
# so we need to set other variables
if(NOT DEFINED BUILD_SHARED_LIBS)
    set(BUILD_SHARED_LIBS OFF CACHE INTERNAL "")
endif()
if(BUILD_SHARED_LIBS)
    set(HELICS_BUILD_CXX_SHARED_LIB ON CACHE BOOL "")
    set(HELICS_DISABLE_C_SHARED_LIB OFF CACHE BOOL "")
    set(old_build_shared ON)
    # we need this to prevent submodules from building shared libs
    set(BUILD_SHARED_LIBS OFF CACHE BOOL "" FORCE)
endif()

cmake_dependent_option(
    HELICS_BUILD_TESTS "Enable the HELICS test executables to be built" OFF
    "BUILD_TESTING;CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME" OFF
)

cmake_dependent_option(
    HELICS_BUILD_EXAMPLES "Build HELICS examples" OFF "CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME"
    OFF
)

cmake_dependent_option(
    HELICS_BUILD_BENCHMARKS "Build HELICS Benchmarks" OFF
    "CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME" OFF
)

cmake_dependent_advanced_option(
    HELICS_WITH_CMAKE_PACKAGE "Generate and install cmake package files" ON
    "CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME" OFF
)

option(HELICS_BINARY_ONLY_INSTALL "only install the helics binary executables" OFF)
mark_as_advanced(HELICS_BINARY_ONLY_INSTALL)

# Install instructions for this target
if(HELICS_WITH_CMAKE_PACKAGE)
    set(HELICS_EXPORT_COMMAND EXPORT helics-targets)
else(HELICS_WITH_CMAKE_PACKAGE)
    set(HELICS_EXPORT_COMMAND)
endif(HELICS_WITH_CMAKE_PACKAGE)

option(HELICS_DISABLE_C_SHARED_LIB OFF "turn off building of the HELICS C shared library interface")
mark_as_advanced(HELICS_DISABLE_C_SHARED_LIB)

option(HELICS_BUILD_CXX_SHARED_LIB "build the shared libraries for the HELICS CXX interface" OFF)

cmake_dependent_advanced_option(
    HELICS_USE_POSITION_INDEPENDENT_CODE
    "Build the libraries with Position independent code Useful if only building the static library and it will be used later in a shared library"
    OFF
    "HELICS_DISABLE_C_SHARED_LIB;NOT HELICS_BUILD_CXX_SHARED_LIB"
    ON
)

cmake_dependent_option(
    HELICS_GENERATE_DOXYGEN_DOC "Generate HELICS Doxygen doc target" OFF
    "CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME" OFF
)

if(NOT HELICS_DISABLE_C_SHARED_LIB OR HELICS_BUILD_CXX_SHARED_LIB
   OR HELICS_USE_POSITION_INDEPENDENT_CODE
)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

option(HELICS_ENABLE_LOGGING "enable normal, debug, and trace logging in HELICS" ON)

cmake_dependent_advanced_option(
    HELICS_ENABLE_TRACE_LOGGING "enable trace logging" ON "HELICS_ENABLE_LOGGING" ON
)
cmake_dependent_advanced_option(
    HELICS_ENABLE_DEBUG_LOGGING "enable debug logging" ON "HELICS_ENABLE_LOGGING" ON
)

include(commonBuildFlags)

# add a baseline library for underlying dependencies and flags
add_library(helics_base INTERFACE)

add_library(HELICS::compile_flags_target ALIAS compile_flags_target)
add_library(HELICS::build_flags_target ALIAS build_flags_target)

get_target_property(EXTRA_BUILD_FLAGS build_flags_target INTERFACE_COMPILE_OPTIONS)

# -------------------------------------------------------------
# add coverage target
# -------------------------------------------------------------

cmake_dependent_advanced_option(
    HELICS_TEST_CODE_COVERAGE "Build a target for testing code coverage" OFF "HELICS_BUILD_TESTS"
    OFF
)

if(HELICS_BUILD_TESTS AND HELICS_TEST_CODE_COVERAGE)
    if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
        include(CodeCoverage)

        set(COVERAGE_EXCLUDES
            'usr/*'
            'dependencies/*'
            'ThirdParty/*'
            'tests/*'
            'interfaces/*'
            'examples/*'
            'benchmarks/*'
            'scripts/*'
        )
        setup_target_for_coverage(
            NAME helics_coverage # New target name
            EXECUTABLE CTest # Executable in PROJECT_BINARY_DIR
        )
    else()
        message(FATAL_ERROR "CMAKE_BUILD_TYPE must be set to Coverage for testing code coverage")
    endif()
endif()

if(HELICS_GENERATE_DOXYGEN_DOC)
    find_package(Doxygen)
    if(DOXYGEN_FOUND)

        show_variable(
            DOXYGEN_OUTPUT_DIR PATH "location to put Doxygen docs" "${HELICS_BINARY_DIR}/docs"
        )
        configure_file(${HELICS_SOURCE_DIR}/config/Doxyfile.in ${HELICS_BINARY_DIR}/Doxyfile @ONLY)
        add_custom_target(
            helics_doxygen
            ${DOXYGEN_EXECUTABLE} ${HELICS_BINARY_DIR}/Doxyfile
            WORKING_DIRECTORY ${DOXYGET_OUTPUT_DIR}
            COMMENT "Generating API documentation with Doxygen"
            VERBATIM
        )
        set_target_properties(helics_doxygen PROPERTIES FOLDER docs)
    endif(DOXYGEN_FOUND)
endif(HELICS_GENERATE_DOXYGEN_DOC)

# -------------------------------------------------------------
# Update git submodules
# -------------------------------------------------------------
if(NOT HELICS_DISABLE_GIT_OPERATIONS)
    include(updateGitSubmodules)
    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/fmtlib/CMakeLists.txt")
        submod_update(ThirdParty/fmtlib)
    endif()

    if(NOT HELICS_DISABLE_ASIO)
        if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/asio/asio/include/asio.hpp")
            submod_update(ThirdParty/asio)
        endif()
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/json_cpp/CMakeLists.txt")
        submod_update(ThirdParty/json_cpp)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/containers/gmlc/containers/BlockingQueue.hpp")
        submod_update(ThirdParty/containers)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/concurrency/gmlc/concurrency/Barrier.hpp")
        submod_update(ThirdParty/concurrency)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/utilities/gmlc/utilities/stringOps.h")
        submod_update(ThirdParty/utilities)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/networking/gmlc/networking/TcpServer.h")
        submod_update(ThirdParty/networking)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/units/units/units.hpp")
        submod_update(ThirdParty/units)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/toml/toml/value.hpp")
        submod_update(ThirdParty/toml)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/spdlog/CMakeLists.txt")
        submod_update(ThirdParty/spdlog)
    endif()
    check_submodule_status()

endif() # NOT HELICS_DISABLE_GIT_OPERATIONS
include(GNUInstallDirs)

# -------------------------------------------------------------
# BOOST  find the boost libraries
# -------------------------------------------------------------

if(NOT HELICS_DISABLE_BOOST)
    include(addBoost)
endif()

# -------------------------------------------------------------
# TOML11  add the TOML interpreter
# -------------------------------------------------------------
if(NOT TARGET toml11::toml11)
    set(toml11_BUILD_TEST OFF CACHE INTERNAL "")
    set(toml11_TEST_WITH_ASAN OFF CACHE INTERNAL "")
    set(toml11_TEST_WITH_UBSAN OFF CACHE INTERNAL "")
    set(toml11_INSTALL OFF CACHE INTERNAL "")
    add_subdirectory(ThirdParty/toml EXCLUDE_FROM_ALL)
    hide_variable(TOML11_USE_UNRELEASED_TOML_FEATURES)
endif()

# -------------------------------------------------------------
# options for enabling specific core communication types
# -------------------------------------------------------------

option(HELICS_ENABLE_MPI_CORE "Enable MPI networking library" OFF)
cmake_dependent_advanced_option(
    HELICS_ENABLE_TCP_CORE "Enable TCP core types" ON "NOT HELICS_DISABLE_ASIO" OFF
)
cmake_dependent_advanced_option(
    HELICS_ENABLE_UDP_CORE "Enable UDP core types" ON "NOT HELICS_DISABLE_ASIO" OFF
)
if("${CMAKE_SYSTEM_NAME}" MATCHES ".*BSD")
    set(SYSTEM_IS_BSD ON)
endif()

cmake_dependent_advanced_option(
    HELICS_ENABLE_IPC_CORE "Enable Interprocess communication types" ON

=== InteropExample/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

add_executable(interopFed1 InterOpFed1.cpp)

target_link_libraries(interopFed1 PUBLIC helics_application_api)
target_link_libraries(interopFed1 PRIVATE compile_flags_target)
set_target_properties(interopFed1 PROPERTIES FOLDER examples)

add_executable(interopFed2 InterOpFed2.cpp)

target_link_libraries(interopFed2 PUBLIC helics_application_api)
target_link_libraries(interopFed2 PRIVATE compile_flags_target)
set_target_properties(interopFed2 PROPERTIES FOLDER examples)

=== csharp/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(SWIG_EXECUTABLE)
    # Enable generation using swig

    set_property(SOURCE helicsCsharp.i PROPERTY SWIG_MODULE_NAME helics)
    # set_source_files_properties(helicsCsharp.i PROPERTIES SWIG_FLAGS "-outfile;helics.cs")
    set_property(SOURCE file.i PROPERTY USE_LIBRARY_INCLUDE_DIRECTORIES TRUE)
    set(CMAKE_SWIG_FLAGS "-outfile;helics.cs;-I${PROJECT_BINARY_DIR}/helics_generated_includes/")
    # set(SWIG_INCLUDE_DIRECTORIES ${PROJECT_BINARY_DIR}/helics_generated_includes/)

    swig_add_library(
        CShelics
        TYPE MODULE
        LANGUAGE csharp
        SOURCES helicsCsharp.i
    )

    swig_link_libraries(CShelics helics)

    set_target_properties(
        ${SWIG_MODULE_CShelics_REAL_NAME} PROPERTIES FOLDER interfaces DEBUG_POSTFIX ""
    )

    target_include_directories(
        ${SWIG_MODULE_CShelics_REAL_NAME} PRIVATE ${HELICS_BINARY_DIR}/helics_generated_includes/
    )

else()
    message(SEND_ERROR "C# interface build requires swig")
endif() # SWIG_EXECUTABLE

# Set the output library name to _helics
set_target_properties(${SWIG_MODULE_CShelics_REAL_NAME} PROPERTIES DEBUG_POSTFIX "")

install_key_files_with_comp(csharp)

install(TARGETS ${SWIG_MODULE_CShelics_REAL_NAME} DESTINATION csharp COMPONENT csharp)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/helics.cs DESTINATION csharp COMPONENT csharp)

=== helics/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# add a baseline library for underlying dependencies and flags for test executables

include(AddGoogletest)

# add a baseline library for underlying dependencies and flags for test executables
add_library(helics_test_base INTERFACE)
target_link_libraries(helics_test_base INTERFACE gtest gtest_main gmock)
target_link_libraries(helics_test_base INTERFACE compile_flags_target spdlog::spdlog)
target_include_directories(helics_test_base INTERFACE ${PROJECT_SOURCE_DIR}/ThirdParty)

add_subdirectory(core)
add_subdirectory(network)
add_subdirectory(common)
add_subdirectory(system_tests)
add_subdirectory(sequencing_tests)

if(HELICS_BUILD_APP_LIBRARY)
    add_subdirectory(apps)
    add_subdirectory(webserver)
endif()

add_subdirectory(application_api)

if(NOT HELICS_DISABLE_C_SHARED_LIB)
    add_subdirectory(shared_library)
endif()

# Configure files for encryption tests
if(HELICS_ENABLE_ENCRYPTION)
    configure_file(
        "test_files/encryption_config/openssl.json.in" "test_files/encryption_config/openssl.json"
    )
    configure_file(
        "test_files/encryption_config/multiBroker_encrypted_bridge.json.in"
        "test_files/encryption_config/multiBroker_encrypted_bridge.json"
    )
endif()

if(HELICS_INSTALL_PACKAGE_TESTS)
    set(HELICS_PACKAGE_SEARCH_LOC)
else()
    set(HELICS_PACKAGE_SEARCH_LOC "-DHELICS_DIR=${PROJECT_BINARY_DIR}")
endif()

if(NOT MSVC)
    set(package_test_command --test-command "${CMAKE_CTEST_COMMAND}")
else() # don't try to run the tests on MSVC since that would require copying the dll's and doing
       # some other setup that isn't that important to run on all OS
    set(package_test_command)
endif()

if(CMAKE_BUILD_TYPE)
    set(HELICS_PACKAGE_TEST_BUILD_TYPE ${CMAKE_BUILD_TYPE})
else()
    set(HELICS_PACKAGE_TEST_BUILD_TYPE Release)
endif()

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests")

if(MSVC AND ${CMAKE_VERSION} VERSION_GREATER 3.12.9)
    # Tests for other CMake projects including and using HELICS using find_package
    add_test(
        NAME find-package-testsA
        COMMAND
            ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" -A "${CMAKE_GENERATOR_PLATFORM}"
            ${HELICS_PACKAGE_SEARCH_LOC}
            "-DHELICS_BUILD_CXX_SHARED_LIB=${HELICS_BUILD_CXX_SHARED_LIB}"
            "-DHELICS_DISABLE_C_SHARED_LIB=${HELICS_DISABLE_C_SHARED_LIB}"
            "-DHELICS_VERSION=${HELICS_VERSION}" "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
            "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
            "-DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
            "${CMAKE_CURRENT_SOURCE_DIR}/find_package_tests"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests"
    )
else()
    add_test(
        NAME find-package-testsA
        COMMAND
            ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" ${HELICS_PACKAGE_SEARCH_LOC}
            "-DHELICS_BUILD_CXX_SHARED_LIB=${HELICS_BUILD_CXX_SHARED_LIB}"
            "-DHELICS_DISABLE_C_SHARED_LIB=${HELICS_DISABLE_C_SHARED_LIB}"
            "-DHELICS_BUILD_APP_LIBRARY=${HELICS_BUILD_APP_LIBRARY}"
            "-DHELICS_VERSION=${HELICS_VERSION}" "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
            "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
            "-DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
            "${CMAKE_CURRENT_SOURCE_DIR}/find_package_tests"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests"
    )
endif()

add_test(NAME find-package-testsB
         COMMAND ${CMAKE_COMMAND} --build "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests" --config
                 ${HELICS_PACKAGE_TEST_BUILD_TYPE}
)

add_test(NAME find-package-testsC COMMAND ${CMAKE_CTEST_COMMAND} -C
                                          ${HELICS_PACKAGE_TEST_BUILD_TYPE}
         WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/find_package_tests"
)
set_property(TEST find-package-testsA PROPERTY LABELS Packaging PackagingFast)
set_property(TEST find-package-testsB PROPERTY LABELS Packaging PackagingFast)
set_property(TEST find-package-testsB PROPERTY DEPENDS find-package-testsA)
set_property(TEST find-package-testsC PROPERTY LABELS Packaging PackagingFast)
set_property(TEST find-package-testsC PROPERTY DEPENDS find-package-testsB)

cmake_dependent_advanced_option(
    HELICS_ENABLE_SUBPROJECT_TESTS
    "Enable tests of using HELICS as a subproject, potentially a slow tests" OFF
    "HELICS_BUILD_TESTS" OFF
)

# Tests for adding HELICS as a subproject using add_subdirectory
if(HELICS_ENABLE_SUBPROJECT_TESTS)
    add_test(
        add-subdirectory-tests
        ${CMAKE_CTEST_COMMAND}
        -C
        ${HELICS_PACKAGE_TEST_BUILD_TYPE}
        --build-and-test
        "${CMAKE_CURRENT_SOURCE_DIR}/add_subdirectory_tests"
        "${CMAKE_CURRENT_BINARY_DIR}/add_subdirectory_tests"
        --build-generator
        "${CMAKE_GENERATOR}"
        --build-generator-platform
        "${CMAKE_GENERATOR_PLATFORM}"
        --build-options
        "-DHELICS_BUILD_CXX_SHARED_LIB=${HELICS_BUILD_CXX_SHARED_LIB}"
        "-DHELICS_DISABLE_C_SHARED_LIB=${HELICS_DISABLE_C_SHARED_LIB}"
        "-DHELICS_BUILD_APP_LIBRARY=${HELICS_BUILD_APP_LIBRARY}"
        "-DHELICS_VERSION=${HELICS_VERSION}"
        "-DZeroMQ_INSTALL_PATH=${ZeroMQ_INSTALL_PATH}"
        "-DBOOST_INSTALL_PATH=${BOOST_INSTALL_PATH}"
        "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
        "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    )
    set_property(TEST add-subdirectory-tests PROPERTY LABELS Packaging)
endif()

if(NOT MSVC AND HELICS_INSTALL_PACKAGE_TESTS)
    # Tests for other CMake projects using the package_config files
    add_test(
        package-config-tests
        ${CMAKE_CTEST_COMMAND}
        -C
        ${HELICS_PACKAGE_TEST_BUILD_TYPE}
        --build-and-test
        "${CMAKE_CURRENT_SOURCE_DIR}/package_config_tests"
        "${CMAKE_CURRENT_BINARY_DIR}/package_config_tests"
        --build-generator
        "${CMAKE_GENERATOR}"
        --build-generator-platform
        "${CMAKE_GENERATOR_PLATFORM}"
        --build-options
        "-DHELICS_BUILD_CXX_SHARED_LIB=${HELICS_BUILD_CXX_SHARED_LIB}"
        "-DHELICS_DISABLE_C_SHARED_LIB=${HELICS_DISABLE_C_SHARED_LIB}"
        "-DHELICS_BUILD_APP_LIBRARY=${HELICS_BUILD_APP_LIBRARY}"
        "-DHELICS_VERSION=${HELICS_VERSION}"
        "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
        "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
        ${package_test_command}
    )
    set_property(TEST package-config-tests PROPERTY LABELS Packaging)
endif()

=== java/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

cmake_minimum_required(VERSION 3.11...3.24)
project(helicsJAVA)

get_directory_property(hasParent PARENT_DIRECTORY)

if(NOT hasParent)
    message(STATUS "Standalone Java interface build")

    # Setup options
    option(HELICS_ENABLE_SWIG "Use SWIG to generate the Java interface files" ON)

    include(GNUInstallDirs)

    # Setup rpath
    if(NOT DEFINED CMAKE_MACOSX_RPATH)
        set(CMAKE_MACOSX_RPATH ON)
    endif()

    if(NOT DEFINED CMAKE_INSTALL_RPATH_USE_LINK_PATH)

        set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

    endif()

    # Add the local directory to the rpath
    if(NOT APPLE)
        list(APPEND CMAKE_INSTALL_RPATH $ORIGIN)
        list(APPEND CMAKE_INSTALL_RPATH "\$ORIGIN/../${CMAKE_INSTALL_LIBDIR}")
    else()
        list(APPEND CMAKE_INSTALL_RPATH "@loader_path")
        list(APPEND CMAKE_INSTALL_RPATH "@loader_path/../${CMAKE_INSTALL_LIBDIR}")
        list(APPEND CMAKE_INSTALL_RPATH "@executable_path")
        list(APPEND CMAKE_INSTALL_RPATH "@executable_path/../${CMAKE_INSTALL_LIBDIR}")
    endif()
endif()

# ##################################################################################################
# Find required dependencies
# ##################################################################################################
# Find HELICS
if(NOT hasParent OR NOT TARGET HELICS::helics)
    find_package(HELICS 3 REQUIRED)
endif()

if(HELICS_ENABLE_SWIG OR HELICS_SWIG_GENERATE_INTERFACE_FILES_ONLY)
    # Find SWIG
    if(NOT DEFINED SWIG_FOUND OR SWIG_VERSION VERSION_LESS 3)
        find_package(SWIG 3 REQUIRED)
        include(${SWIG_USE_FILE})
    endif()

    # Find helics.i swig interface file
    if(NOT HELICS_SWIG_helics.i_FILE)
        foreach(TMPDIR IN LISTS HELICS_SWIG_INCLUDE_DIRS)
            if(NOT HELICS_SWIG_helics.i_FILE)
                if(EXISTS "${TMPDIR}/helics.i")
                    # cmake-format: off
                    set(HELICS_SWIG_helics.i_FILE "${TMPDIR}/helics.i" CACHE FILEPATH "Path to the helics.i file used by swig" FORCE)
                    # cmake-format: on
                endif()
            endif()
        endforeach()
        if(NOT HELICS_SWIG_helics.i_FILE)
            message(
                FATAL_ERROR "Unable to find helics.i file, required for swig to generate interfaces"
            )
        endif()
    endif()
endif()

# CMake UseSWIG doesn't properly propagate include dirs when using target_link_libraries. This is
# also the only way that works with CMake < 3.12
include_directories(${HELICS_SWIG_INCLUDE_DIRS})

# ##################################################################################################
# UseSWIG feature support
# ##################################################################################################
# This can be removed in HELICS 3 if the minimum CMake version is >= 3.12
if(NOT CMAKE_VERSION VERSION_LESS 3.12)
    set(USE_MODERNIZED_SWIG ON)
else()
    set(USE_MODERNIZED_SWIG OFF)
endif()

# ##################################################################################################
# Run SWIG only (no build)
# ##################################################################################################
# Swig doesn't need Java to generate the wrapper files
if(HELICS_SWIG_GENERATE_INTERFACE_FILES_ONLY AND SWIG_EXECUTABLE)
    if(NOT hasParent)
        message(
            FATAL_ERROR
                "`HELICS_SWIG_GENERATE_INTERFACE_FILES_ONLY`  can only be used when building from the root HELICS CMakeLists.txt file"
        )
    endif()
    include(${CMAKE_CURRENT_SOURCE_DIR}/javaSwigGenerateOnly.cmake)
    return()
endif()

# ##################################################################################################
# Find Java libraries
# ##################################################################################################
find_package(Java REQUIRED)
find_package(JNI REQUIRED)
include(UseJava)

if(NOT USE_MODERNIZED_SWIG)
    include_directories(${JAVA_INCLUDE_PATH})
    include_directories(${JAVA_INCLUDE_PATH2})
    include_directories(${JNI_INCLUDE_DIRS})
    include_directories(${HELICS_BINARY_DIR}/helics_generated_includes/)
    include_directories(${HELICS_INCLUDE_DIRS})
    # "Using old SWIG include_directories")
endif()

# ##################################################################################################
# Build the Java interface
# ##################################################################################################
if(HELICS_ENABLE_SWIG AND SWIG_EXECUTABLE)
    set_property(SOURCE helicsJava.i PROPERTY SWIG_MODULE_NAME helics)
    set_property(SOURCE helicsJava.i PROPERTY USE_LIBRARY_INCLUDE_DIRECTORIES TRUE)
    set_property(SOURCE helicsJava.i PROPERTY DEPENDS HELICS::helics)
    set_property(
        SOURCE helicsJava.i
        PROPERTY INCLUDE_DIRECTORIES ${HELICS_BINARY_DIR}/helics_generated_includes/
                 ${HELICS_INCLUDE_DIRS}
    )
    set(CMAKE_SWIG_FLAGS "-package;com.java.helics")

    if(SWIG_VERSION VERSION_GREATER 4.0.0)
        set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} "-doxygen" "-w560")
    endif()

    swig_add_library(
        helicsJava
        TYPE MODULE
        LANGUAGE java
        SOURCES helicsJava.i
    )
    set_property(TARGET helicsJava PROPERTY SWIG_USE_LIBRARY_INCLUDE_DIRECTORIES TRUE)
    set_property(TARGET helicsJava PROPERTY SWIG_DEPENDS HELICS::helics)
    swig_link_libraries(helicsJava HELICS::helics)
    swig_link_libraries(helicsJava ${JAVA_LIBRARIES})

    if(USE_MODERNIZED_SWIG)
        target_include_directories(${SWIG_MODULE_helicsJava_REAL_NAME} PRIVATE ${JAVA_INCLUDE_PATH})
        target_include_directories(
            ${SWIG_MODULE_helicsJava_REAL_NAME} PRIVATE ${JAVA_INCLUDE_PATH2}
        )
        target_include_directories(${SWIG_MODULE_helicsJava_REAL_NAME} PRIVATE ${JNI_INCLUDE_DIRS})
        target_include_directories(
            ${SWIG_MODULE_helicsJava_REAL_NAME}
            PRIVATE ${HELICS_BINARY_DIR}/helics_generated_includes/ ${HELICS_INCLUDE_DIRS}
        )

        message(STATUS "Using new swig target_include_directories")
    endif()

    if(MSVC)
        target_compile_options(${SWIG_MODULE_helicsJava_REAL_NAME} PRIVATE "/wd4100")
    else()
        target_compile_options(
            ${SWIG_MODULE_helicsJava_REAL_NAME} PRIVATE -Wno-deprecated-declarations
        )
        if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
            target_compile_options(
                ${SWIG_MODULE_helicsJava_REAL_NAME} PRIVATE -Wno-long-long -Wno-strict-aliasing
            )
        endif()
    endif()

    set_target_properties(
        ${SWIG_MODULE_helicsJava_REAL_NAME} PROPERTIES FOLDER interfaces DEBUG_POSTFIX ""
    )
    add_library(helics::java ALIAS ${SWIG_MODULE_helicsJava_REAL_NAME})
    message(STATUS "java target is ${SWIG_MODULE_helicsJava_REAL_NAME}")
    set(HELICS_JAVA_TARGET ${SWIG_MODULE_helicsJava_REAL_NAME})
else()
    message(STATUS "Building without swig")
    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/interface/ DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

    add_library(helicsJava SHARED interface/helicsJava.c)
    target_link_libraries(helicsJava HELICS::helics ${JAVA_LIBRARIES})
    target_include_directories(helicsJava PRIVATE ${JAVA_INCLUDE_PATH})
    target_include_directories(helicsJava PRIVATE ${JAVA_INCLUDE_PATH2})
    target_include_directories(helicsJava PRIVATE ${JNI_INCLUDE_DIRS})

    if(MSVC)
        target_compile_options(helicsJava PRIVATE "/wd4100")
    else()
        target_compile_options(helicsJava PRIVATE -Wno-deprecated-declarations)
        if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
            target_compile_options(helicsJava PRIVATE -Wno-long-long -Wno-strict-aliasing)
        endif()
    endif()

    set_target_properties(helicsJava PROPERTIES FOLDER interfaces DEBUG_POSTFIX "")

    add_library(helics::java ALIAS helicsJava)
    set(HELICS_JAVA_TARGET helicsJava)
endif()

# ##################################################################################################
# Make JAR file
# ##################################################################################################
configure_file(MakeJarCMakeLists.txt.in ${CMAKE_CURRENT_BINARY_DIR}/jarproject/CMakeLists.txt @ONLY)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/jarproject/buildjar/)

# -D ADDITIONAL_JAR_FILES=$<TARGET_FILE:helics>;$<TARGET_FILE:helicsJava>
add_custom_command(
    TARGET ${HELICS_JAVA_TARGET} POST_BUILD
    COMMAND ${CMAKE_COMMAND} -D LIBRARY_FILE=$<TARGET_FILE:${HELICS_JAVA_TARGET}> -P
            ${CMAKE_CURRENT_SOURCE_DIR}/addLoadLibraryCommand.cmake
)

if(CMAKE_GENERATOR_PLATFORM)
    add_custom_command(
        TARGET ${HELICS_JAVA_TARGET}
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -G ${CMAKE_GENERATOR} -A ${CMAKE_GENERATOR_PLATFORM} ..
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/jarproject/buildjar"
        VERBATIM
    )
else()
    add_custom_command(
        TARGET ${HELICS_JAVA_TARGET}
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -G ${CMAKE_GENERATOR} ..
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/jarproject/buildjar"
        VERBATIM
    )
endif()

add_custom_command(
    TARGET ${HELICS_JAVA_TARGET}
    POST_BUILD
    COMMAND ${CMAKE_COMMAND} ARGS --build ./ --target helics
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/jarproject/buildjar"
    COMMENT "Building jar file"
    VERBATIM
)

# ##################################################################################################
# Install steps
# ##################################################################################################
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/jarproject/buildjar/helics-${HELICS_VERSION}.jar
        DESTINATION java COMPONENT java
)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/jarproject/buildjar/helics.jar
    DESTINATION java
    COMPONENT java
    OPTIONAL
)
install(TARGETS ${HELICS_JAVA_TARGET} DESTINATION java COMPONENT java)

# Copy/install commands for shared libraries are only needed on Windows, which doesn't support
# rpaths
if(WIN32)
    if(COMMAND install_key_files_with_comp)
        install_key_files_with_comp(java)
    else()
        install(FILES "$<TARGET_FILE:HELICS::helics>" DESTINATION java COMPONENT java)
    endif()
endif()

=== octave/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Generate SWIG wrapper (for Octave)
message(STATUS "Building Octave interface")

find_package(Octave REQUIRED)
if(NOT MKOCTFILE_EXECUTABLE)
    show_variable(
        OCTAVE_INSTALL_LOCATION PATH "installation location for Octave"
        "${OCTAVE_INSTALL_LOCATION}"
    )
endif()

# custom command for building the wrap file
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/helicsOCTAVE_wrap.cxx
    COMMAND
        "${SWIG_EXECUTABLE}" "-octave" "-c++" -o "helicsOCTAVE_wrap.cxx"
        "-I${PROJECT_BINARY_DIR}/helics_generated_includes/"
        ${CMAKE_CURRENT_SOURCE_DIR}/helicsOctave.i
    DEPENDS ${PROJECT_SOURCE_DIR}/interfaces/helics.i ${CMAKE_CURRENT_SOURCE_DIR}/helicsOctave.i
            ${CMAKE_CURRENT_SOURCE_DIR}/octave_maps.i
            ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/helicsOCTAVE_wrap.cpp
    COMMAND ${CMAKE_COMMAND} -D VOID_SIZE=${CMAKE_SIZEOF_VOID_P} -P
            ${CMAKE_CURRENT_SOURCE_DIR}/modifyOctSourceFile.cmake
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/helicsOCTAVE_wrap.cxx
)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/mkhelicsOCTFile.m
    COMMAND
        ${CMAKE_COMMAND} -D LIBRARY_FILE=$<TARGET_LINKER_FILE:helics> -D
        BUILD_FILE=${CMAKE_CURRENT_BINARY_DIR}/helicsOCTAVE_wrap.cpp -D
        LIBRARY_INCLUDE_LOCATION=${PROJECT_SOURCE_DIR}/src/helics/ -D
        OTHER_INCLUDE_LOCATION=${PROJECT_BINARY_DIR}/helics_generated_includes/ -D
        SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} -P
        ${CMAKE_CURRENT_SOURCE_DIR}/generateOCTcreationScript.cmake
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/helicsOCTAVE_wrap.cpp
)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/helics.oct
    COMMAND ${OCTAVE_EXECUTABLE} "-q" "\"${CMAKE_CURRENT_BINARY_DIR}/mkhelicsOCTFile.m\""
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/mkhelicsOCTFile.m helics
            ${CMAKE_CURRENT_BINARY_DIR}/helicsOCTAVE_wrap.cpp
)

add_custom_target(helicsOCT ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/helics.oct)

set_target_properties(helicsOCT PROPERTIES FOLDER interfaces)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/helics.oct DESTINATION octave COMPONENT octave)
install_key_files_with_comp(octave)

=== concurrency/gmlc/CMakeLists.txt ===
# ~~~
# Copyright (c) 2017-2023, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~

set(concurrency_headers
    concurrency/TriggerVariable.hpp
    concurrency/DelayedObjects.hpp
    concurrency/TripWire.hpp
    concurrency/DelayedDestructor.hpp
    concurrency/SearchableObjectHolder.hpp
    concurrency/Barrier.hpp
    concurrency/Latch.hpp
    libguarded/atomic_guarded.hpp
    libguarded/cow_guarded.hpp
    libguarded/deferred_guarded.hpp
    libguarded/guarded.hpp
    libguarded/guarded_opt.hpp
    libguarded/handles.hpp
    libguarded/lr_guarded.hpp
    libguarded/ordered_guarded.hpp
    libguarded/rcu_guarded.hpp
    libguarded/rcu_list.hpp
    libguarded/shared_guarded.hpp
    libguarded/shared_guarded_opt.hpp
    libguarded/staged_guarded.hpp
)

set(concurrency_sources empty.cpp)

add_library(concurrency STATIC ${concurrency_sources} ${concurrency_headers})

target_link_libraries(concurrency concurrency_base)
target_include_directories(concurrency INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

if(GMLC_CONCURRENCY_CLANG_TIDY)
    set_property(TARGET concurrency PROPERTY CXX_CLANG_TIDY "${DO_CLANG_TIDY}")
endif()

=== helics/application_api/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(application_api_headers
    CombinationFederate.hpp
    CallbackFederate.hpp
    Publications.hpp
    Subscriptions.hpp
    Endpoints.hpp
    Filters.hpp
    Translator.hpp
    Federate.hpp
    helicsTypes.hpp
    data_view.hpp
    MessageFederate.hpp
    MessageOperators.hpp
    ValueConverter.hpp
    ValueFederate.hpp
    HelicsPrimaryTypes.hpp
    queryFunctions.hpp
    FederateInfo.hpp
    Inputs.hpp
    BrokerApp.hpp
    CoreApp.hpp
)

set(conv_headers ../application_api.hpp ../ValueFederates.hpp ../MessageFederates.hpp)

set(private_application_api_headers
    MessageFederateManager.hpp
    ValueFederateManager.hpp
    AsyncFedCallInfo.hpp
    FilterOperations.hpp
    ConnectorFederateManager.hpp
    TranslatorOperations.hpp
    PotentialInterfacesManager.hpp
)

set(application_api_sources
    CombinationFederate.cpp
    Federate.cpp
    MessageFederate.cpp
    MessageFederateManager.cpp
    MessageOperators.cpp
    ValueFederate.cpp
    ValueConverter.cpp
    ValueFederateManager.cpp
    helicsPrimaryTypes.cpp
    Publications.cpp
    Filters.cpp
    FilterOperations.cpp
    ConnectorFederateManager.cpp
    PotentialInterfacesManager.cpp
    Translator.cpp
    TranslatorOperations.cpp
    Endpoints.cpp
    helicsTypes.cpp
    queryFunctions.cpp
    FederateInfo.cpp
    CallbackFederate.cpp
    Inputs.cpp
    BrokerApp.cpp
    CoreApp.cpp
)

add_library(
    helics_application_api STATIC ${application_api_sources} ${conv_headers}
                                  ${application_api_headers} ${private_application_api_headers}
)

target_link_libraries(helics_application_api PUBLIC HELICS::network)
target_link_libraries(helics_application_api PRIVATE fmt::fmt)
target_compile_definitions(helics_application_api PUBLIC HELICS_CXX_STATIC_DEFINE)
if(MSYS AND USE_LIBCXX)
    target_compile_definitions(helics_application_api PUBLIC "-DSTX_NO_STD_OPTIONAL=1")
endif()

add_library(HELICS::application_api ALIAS helics_application_api)

=== helics/apps/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(HELICS_BUILD_APP_LIBRARY)

    cmake_dependent_advanced_option(
        HELICS_DISABLE_WEBSERVER
        "Disable the embedded webserver app structure in the broker server" OFF
        "NOT HELICS_DISABLE_BOOST;Boost_VERSION VERSION_GREATER 1.69" ON
    )
    set(helics_apps_public_headers
        Player.hpp
        Recorder.hpp
        Echo.hpp
        Source.hpp
        Tracer.hpp
        helicsApp.hpp
        Clone.hpp
        CoreApp.hpp
        Probe.hpp
        Connector.hpp
        BrokerApp.hpp
    )

    set(helics_apps_broker_headers MultiBroker.hpp BrokerServer.hpp zmqBrokerServer.hpp
                                   AsioBrokerServer.hpp TypedBrokerServer.hpp
    )

    set(helics_apps_private_headers PrecHelper.hpp SignalGenerators.hpp)

    set(helics_apps_library_files
        Player.cpp
        Recorder.cpp
        PrecHelper.cpp
        SignalGenerators.cpp
        Echo.cpp
        Source.cpp
        Tracer.cpp
        helicsApp.cpp
        Clone.cpp
        Probe.cpp
        Connector.cpp
    )

    set(helics_apps_broker_files MultiBroker.cpp BrokerServer.cpp zmqBrokerServer.cpp
                                 TypedBrokerServer.cpp
    )

    if(NOT HELICS_DISABLE_ASIO)
        list(APPEND helics_apps_broker_files AsioBrokerServer.cpp)
    endif()

    if(BOOST_VERSION_LEVEL GREATER 69 AND NOT (HELICS_DISABLE_WEBSERVER OR HELICS_DISABLE_BOOST
                                               OR HELICS_DISABLE_ASIO)
    )
        message(STATUS "Building webserver Boost version ${Boost_VERSION} ${BOOST_VERSION_LEVEL}")
        list(APPEND helics_apps_broker_files helicsWebServer.cpp RestApiConnection.cpp)
        list(APPEND helics_apps_broker_headers helicsWebServer.hpp indexPage.hpp
             RestApiConnection.hpp
        )
    endif()

    add_library(
        helics_apps STATIC
        ../helics_apps.hpp
        ${helics_apps_library_files}
        ${helics_apps_public_headers}
        ${helics_apps_broker_headers}
        ${helics_apps_private_headers}
        ${helics_apps_broker_files}
    )

    target_link_libraries(helics_apps PUBLIC HELICS::application_api)
    target_link_libraries(
        helics_apps
        PRIVATE HELICS::compile_flags_target
                spdlog::spdlog
                fmt::fmt
                helics::zmq
                HELICS::common
                gmlc::networking
    )

    if(BOOST_VERSION_LEVEL GREATER 69 AND NOT (HELICS_DISABLE_WEBSERVER OR HELICS_DISABLE_BOOST
                                               OR HELICS_DISABLE_ASIO)
    )
        target_compile_definitions(helics_apps PUBLIC BOOST_DATE_TIME_NO_LIB)
        target_compile_definitions(helics_apps PUBLIC BOOST_BEAST_USE_STD_STRING_VIEW)
        target_compile_definitions(helics_apps PUBLIC HELICS_ENABLE_WEBSERVER=1)
        if(WIN32)
            target_link_libraries(helics_apps PRIVATE bcrypt)
        endif()

        if(MSVC)
            target_compile_options(helics_apps PRIVATE "/bigobj")
        endif()
    endif()
    # add and alias library to match the find_package
    add_library(HELICS::apps ALIAS helics_apps)

    if(HELICS_BUILD_APP_EXECUTABLES)
        add_executable(helics_player playerMain.cpp)
        target_link_libraries(helics_player PUBLIC HELICS::apps)
        target_link_libraries(helics_player PRIVATE compile_flags_target)
        set_target_properties(helics_player PROPERTIES FOLDER apps)
        install(TARGETS helics_player ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT applications
        )

        add_executable(helics_recorder recorderMain.cpp)
        target_link_libraries(helics_recorder PUBLIC HELICS::apps)
        set_target_properties(helics_recorder PROPERTIES FOLDER apps)
        target_link_libraries(helics_recorder PRIVATE compile_flags_target)
        install(TARGETS helics_recorder ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT applications
        )

        add_executable(helics_connector connectorMain.cpp)
        target_link_libraries(helics_connector PUBLIC HELICS::apps)
        target_link_libraries(helics_connector PRIVATE compile_flags_target)
        set_target_properties(helics_connector PROPERTIES FOLDER apps)
        install(TARGETS helics_connector ${HELICS_EXPORT_COMMAND}
                DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications
        )

        add_executable(helics_broker helics-broker.cpp)
        target_link_libraries(helics_broker PUBLIC HELICS::apps)
        target_link_libraries(helics_broker PRIVATE compile_flags_target)
        set_target_properties(helics_broker PROPERTIES FOLDER apps)
        set(HELICS_BROKER_LOC ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
            CACHE INTERNAL "build folder location of the broker"
        )

        add_test(NAME broker_version_return COMMAND helics_broker --version)
        add_test(NAME broker_help_return COMMAND helics_broker --help)
        set_property(TEST broker_version_return broker_help_return PROPERTY LABELS Continuous)

        add_executable(helics_broker_server helics-broker-server.cpp)
        target_link_libraries(helics_broker_server PUBLIC HELICS::apps)
        target_link_libraries(helics_broker_server PRIVATE compile_flags_target)
        set_target_properties(helics_broker_server PROPERTIES FOLDER apps)
        set(HELICS_BROKER_SERVER_LOC ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
            CACHE INTERNAL "build folder location of the broker server"
        )
        install(TARGETS helics_broker helics_broker_server ${HELICS_EXPORT_COMMAND}
                DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications
        )

        add_executable(helics_app appMain.cpp)
        target_link_libraries(helics_app PUBLIC HELICS::apps)
        target_link_libraries(helics_app PRIVATE spdlog::spdlog compile_flags_target)
        set_target_properties(helics_app PROPERTIES FOLDER apps)
        install(TARGETS helics_app ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT applications
        )

        add_test(NAME app_version_return COMMAND helics_app --version)
        add_test(NAME app_help_return COMMAND helics_app --help)
        set_property(TEST app_version_return app_help_return PROPERTY LABELS Continuous)

        add_test(NAME app_subcommand_version_return COMMAND helics_app player --version)
        add_test(NAME app_subcommand_help_return COMMAND helics_app player --help)
        set_property(
            TEST app_subcommand_version_return app_subcommand_help_return PROPERTY LABELS
                                                                                   Continuous
        )
    endif(HELICS_BUILD_APP_EXECUTABLES)

    if(HELICS_BUILD_CXX_SHARED_LIB)
        add_library(
            helicscpp-apps SHARED ../helics_apps.hpp ${helics_apps_library_files}
                                  ${helics_apps_public_headers} ${helics_apps_private_headers}
        )

        target_link_libraries(helicscpp-apps PUBLIC HELICS::helicscpp)
        target_link_libraries(
            helicscpp-apps PRIVATE HELICS::common spdlog::spdlog fmt::fmt gmlc::utilities
                                   gmlc::networking
        )

        # add and alias library to match the find_package
        add_library(HELICS::helicscpp-apps ALIAS helicscpp-apps)

        target_compile_definitions(helicscpp-apps PRIVATE helicscpp_EXPORTS)

        target_include_directories(
            helicscpp-apps
            INTERFACE $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include/helics_cxx>
                      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/ThirdParty>
                      $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>
            PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        )

        set_target_properties(
            helicscpp-apps PROPERTIES VERSION ${HELICS_VERSION} SOVERSION ${HELICS_VERSION_MAJOR}
        )

        set_target_properties(
            helicscpp-apps PROPERTIES CXX_VISIBILITY_PRESET hidden C_VISIBILITY_PRESET hidden
                                      VISIBILITY_INLINES_HIDDEN ON
        )

        install(
            TARGETS helicscpp-apps ${HELICS_EXPORT_COMMAND}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )

        if(WIN32)
            install(FILES $<TARGET_LINKER_FILE:helicscpp-apps> DESTINATION ${CMAKE_INSTALL_LIBDIR}
                    COMPONENT libs
            )
            install(FILES $<TARGET_FILE:helicscpp-apps> DESTINATION ${CMAKE_INSTALL_BINDIR}
                    COMPONENT Runtime
            )
        else()
            install(TARGETS helicscpp-apps DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RUNTIME)
        endif()

        if(NOT HELICS_BINARY_ONLY_INSTALL)

            if(MSVC AND NOT HELICS_EMBEDDED_DEBUG_INFO)
                install(
                    FILES $<TARGET_PDB_FILE:helicscpp-apps>
                    DESTINATION ${CMAKE_INSTALL_BINDIR}
                    OPTIONAL
                    COMPONENT libs
                )
            endif()

        endif()
    endif()

endif(HELICS_BUILD_APP_LIBRARY)

=== helics/network/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(NETWORK_SRC_FILES
    NetworkCommsInterface.cpp
    NetworkBrokerData.cpp
    CommsInterface.cpp
    CommsBroker.cpp
    loadCores.cpp
    networkDefaults.cpp
)

set(TESTCORE_SOURCE_FILES test/TestBroker.cpp test/TestCore.cpp test/TestComms.cpp)

set(INPROCCORE_SOURCE_FILES inproc/InprocBroker.cpp inproc/InprocCore.cpp inproc/InprocComms.cpp)

set(IPC_SOURCE_FILES ipc/IpcCore.cpp ipc/IpcBroker.cpp ipc/IpcComms.cpp ipc/IpcQueueHelper.cpp
                     # ipc/IpcBlockingPriorityQueue.cpp ipc/IpcBlockingPriorityQueueImpl.cpp
)

set(MPI_SOURCE_FILES mpi/MpiCore.cpp mpi/MpiBroker.cpp mpi/MpiComms.cpp mpi/MpiService.cpp)

set(ZMQ_SOURCE_FILES
    zmq/ZmqCore.cpp
    zmq/ZmqBroker.cpp
    zmq/ZmqComms.cpp
    zmq/ZmqCommsSS.cpp
    zmq/ZmqRequestSets.cpp
    zmq/ZmqCommsCommon.cpp
    zmq/ZmqContextManager.cpp
    # zmq/zmqSocketDescriptor.cpp
    zmq/ZmqHelper.cpp
)

set(UDP_SOURCE_FILES udp/UdpCore.cpp udp/UdpBroker.cpp udp/UdpComms.cpp)

set(TCP_SOURCE_FILES tcp/TcpCore.cpp tcp/TcpBroker.cpp tcp/TcpComms.cpp tcp/TcpCommsSS.cpp
                     tcp/TcpCommsCommon.cpp
)

set(NETWORK_INCLUDE_FILES
    NetworkCommsInterface.hpp
    NetworkBrokerData.hpp
    NetworkBroker.hpp
    NetworkCore.hpp
    NetworkBroker_impl.hpp
    NetworkCore_impl.hpp
    networkDefaults.hpp
    CommsBroker.hpp
    CommsBroker_impl.hpp
    CommsInterface.hpp
    loadCores.hpp
)

set(TESTCORE_HEADER_FILES test/TestCore.h test/TestBroker.h test/TestComms.h)

set(INPROCCORE_HEADER_FILES inproc/InprocCore.h inproc/InprocBroker.h inproc/InprocComms.h)

set(IPC_HEADER_FILES ipc/IpcCore.h ipc/IpcBroker.h ipc/IpcComms.h ipc/IpcQueueHelper.h
                     # ipc/IpcBlockingPriorityQueue.hpp ipc/IpcBlockingPriorityQueueImpl.hpp
)

set(ZMQ_HEADER_FILES
    zmq/ZmqCore.h
    zmq/ZmqBroker.h
    zmq/ZmqComms.h
    zmq/ZmqCommsSS.h
    zmq/ZmqRequestSets.h
    zmq/ZmqCommsCommon.h
    zmq/ZmqContextManager.h
    # zmq/zmqSocketDescriptor.h
    zmq/ZmqHelper.h
    ${HELICS_SOURCE_DIR}/ThirdParty/cppzmq/zmq.hpp
    ${HELICS_SOURCE_DIR}/ThirdParty/cppzmq/zmq_addon.hpp
)

set(MPI_HEADER_FILES mpi/MpiCore.h mpi/MpiBroker.h mpi/MpiComms.h mpi/MpiService.h)

set(UDP_HEADER_FILES udp/UdpCore.h udp/UdpBroker.h udp/UdpComms.h)

set(TCP_HEADER_FILES tcp/TcpCore.h tcp/TcpBroker.h tcp/TcpComms.h tcp/TcpCommsSS.h
                     tcp/TcpCommsCommon.h
)

if(HELICS_ENABLE_TEST_CORE)
    list(APPEND NETWORK_SRC_FILES ${TESTCORE_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${TESTCORE_HEADER_FILES})
endif()

if(HELICS_ENABLE_INPROC_CORE)
    list(APPEND NETWORK_SRC_FILES ${INPROCCORE_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${INPROCCORE_HEADER_FILES})
endif()

if(HELICS_ENABLE_UDP_CORE)
    list(APPEND NETWORK_SRC_FILES ${UDP_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${UDP_HEADER_FILES})
endif()

if(HELICS_ENABLE_IPC_CORE)
    list(APPEND NETWORK_SRC_FILES ${IPC_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${IPC_HEADER_FILES})
endif()

if(HELICS_ENABLE_TCP_CORE)
    list(APPEND NETWORK_SRC_FILES ${TCP_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${TCP_HEADER_FILES})
endif()

if(HELICS_ENABLE_ZMQ_CORE)
    list(APPEND NETWORK_SRC_FILES ${ZMQ_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${ZMQ_HEADER_FILES})
endif()

if(HELICS_ENABLE_MPI_CORE)
    list(APPEND NETWORK_SRC_FILES ${MPI_SOURCE_FILES})
    list(APPEND NETWORK_INCLUDE_FILES ${MPI_HEADER_FILES})
endif()

add_library(helics_network STATIC ${NETWORK_SRC_FILES} ${NETWORK_INCLUDE_FILES})

target_link_libraries(
    helics_network PUBLIC HELICS::core PRIVATE gmlc::networking fmt::fmt compile_flags_target
)

if(HELICS_ENABLE_ZMQ_CORE)
    target_link_libraries(helics_network PRIVATE helics::zmq)
endif()

if(TARGET Boost::boost AND NOT HELICS_DISABLE_BOOST)
    target_compile_definitions(helics_network PRIVATE BOOST_DATE_TIME_NO_LIB)
    target_link_libraries(helics_network PRIVATE Boost::boost)
endif()

if(HELICS_ENABLE_MPI_CORE)
    source_group("mpi" FILES ${MPI_SOURCE_FILES} ${MPI_HEADER_FILES})
endif()

if(HELICS_ENABLE_ZMQ_CORE)
    source_group("zmq" FILES ${ZMQ_SOURCE_FILES} ${ZMQ_HEADER_FILES})
endif()

if(HELICS_ENABLE_UDP_CORE)
    source_group("udp" FILES ${UDP_SOURCE_FILES} ${UDP_HEADER_FILES})
endif()

if(HELICS_ENABLE_IPC_CORE)
    source_group("ipc" FILES ${IPC_SOURCE_FILES} ${IPC_HEADER_FILES})
endif()

if(HELICS_ENABLE_TEST_CORE)
    source_group("test" FILES ${TESTCORE_SOURCE_FILES} ${TESTCORE_HEADER_FILES})
endif()

if(HELICS_ENABLE_TCP_CORE)
    source_group("tcp" FILES ${TCP_SOURCE_FILES} ${TCP_HEADER_FILES})
endif()

if(HELICS_ENABLE_INPROC_CORE)
    source_group("inproc" FILES ${INPROCCORE_SOURCE_FILES} ${INPROCCORE_HEADER_FILES})
endif()

if(HELICS_ENABLE_MPI_CORE)
    target_include_directories(
        helics_network PRIVATE "${MPI_C_INCLUDE_DIR}" "${MPI_C_HEADER_DIR}"
                               "${MPI_C_ADDITIONAL_INCLUDE_DIRS}"
    )
endif()

add_library(HELICS::network ALIAS helics_network)

target_compile_options(
    helics_network
    PRIVATE $<$<COMPILE_LANGUAGE:CXX>:$<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-Wno-strict-aliasing>>
)

=== helics/shared_api_library/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2024, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(helicsShared_headers
    helicsCore.h
    helicsData.h
    api-data.h
    ValueFederate.h
    MessageFederate.h
    MessageFilters.h
    Translators.h
    helicsCallbacks.h
)

set(helicsShared_sources
    helicsExport.cpp
    FederateExport.cpp
    ValueFederateExport.cpp
    MessageFederateExport.cpp
    MessageFiltersExport.cpp
    TranslatorExport.cpp
    helicsCallbacks.cpp
    helicsData.cpp
    internal/api_objects.h
)

include(GenerateExportHeader)

if(Python_EXECUTABLE)
    add_custom_command(
        OUTPUT ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
               ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
        COMMAND ${Python_EXECUTABLE} ARGS ${PROJECT_SOURCE_DIR}/scripts/generateHelicsH.py
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/ ${PROJECT_SOURCE_DIR}
        DEPENDS helicsCore.h
                helicsCallbacks.h
                MessageFederate.h
                ValueFederate.h
                MessageFilters.h
                Translators.h
                helicsData.h
                helicsCore.h
                Translators.h
                api-data.h
                ../helics_enums.h
    )

    # this section is for developer convenience to make sure the backup files get copied over when
    # working on the C API
    if(HELICS_OVERWRITE_BACKUP_H_FILES)
        add_custom_target(
            overwrite_backup_files ALL
            DEPENDS ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
                    ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
        )
        add_custom_command(
            TARGET overwrite_backup_files
            POST_BUILD
            COMMAND
                ${CMAKE_COMMAND} -E copy
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
                ${PROJECT_SOURCE_DIR}/src/helics/shared_api_library/backup/helics DEPENDS
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
        )
        add_custom_command(
            TARGET overwrite_backup_files
            POST_BUILD
            COMMAND
                ${CMAKE_COMMAND} -E copy
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
                ${PROJECT_SOURCE_DIR}/src/helics/shared_api_library/backup/helics DEPENDS
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
        )

        set_target_properties(overwrite_backup_files PROPERTIES FOLDER interfaces)
    endif()
else()
    configure_file(
        ${PROJECT_SOURCE_DIR}/src/helics/shared_api_library/backup/helics/helics.h
        ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h COPYONLY
    )
    configure_file(
        ${PROJECT_SOURCE_DIR}/src/helics/shared_api_library/backup/helics/helics_api.h
        ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h COPYONLY
    )
endif()

add_library(
    helics SHARED ${helicsShared_sources} ${helicsShared_headers}
                  ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
)

add_library(HELICS::helics ALIAS helics)
generate_export_header(helics BASE_NAME helics)

target_include_directories(
    helics PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    INTERFACE $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/helics_generated_includes>
              $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>
)

set_target_properties(helics PROPERTIES VERSION ${HELICS_VERSION} SOVERSION ${HELICS_VERSION_MAJOR})

set_target_properties(helics PROPERTIES CXX_VISIBILITY_PRESET hidden C_VISIBILITY_PRESET hidden)
target_link_libraries(helics PRIVATE helics_application_api)
target_link_libraries(helics PRIVATE compile_flags_target)

if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6.0)
    target_compile_options(helics PUBLIC -Wno-documentation)
endif()

if(UNIX OR MINGW)
    if(NOT APPLE)
        if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
            include(CheckLinkerFlag)
            check_linker_flag(
                CXX "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/export.txt"
                flag_linker_version_script
            )
            if(flag_linker_version_script)
                target_link_libraries(
                    helics PRIVATE -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/export.txt
                )
            endif()
            check_linker_flag(CXX "-Wl,--exclude-libs,ALL" flag_linker_exclude_libs)
            if(flag_linker_exclude_libs)
                target_link_libraries(helics PRIVATE -Wl,--exclude-libs,ALL)
            endif()
        else()
            target_link_libraries(
                helics PRIVATE -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/export.txt
            )
            target_link_libraries(helics PRIVATE -Wl,--exclude-libs,ALL)
        endif()
    else(NOT_APPLE)
        target_link_libraries(
            helics PRIVATE -Wl,-exported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/export_mac.txt
        )
    endif(NOT APPLE)
endif()

set_target_properties(helics PROPERTIES FOLDER interfaces)

install(
    TARGETS helics ${HELICS_EXPORT_COMMAND}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

if(WIN32)
    install(
        FILES $<TARGET_LINKER_FILE:helics>
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT libs
        EXCLUDE_FROM_ALL
    )
    install(
        FILES $<TARGET_FILE:helics>
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT Runtime
        EXCLUDE_FROM_ALL
    )
else()
    install(
        TARGETS helics
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT RUNTIME
        EXCLUDE_FROM_ALL
    )
endif()

if(MSVC AND NOT HELICS_EMBEDDED_DEBUG_INFO)
    install(
        FILES $<TARGET_PDB_FILE:helics>
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        OPTIONAL
        COMPONENT libs
    )
endif()

if(NOT HELICS_BINARY_ONLY_INSTALL)
    install(FILES ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
                  ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/helics COMPONENT headers
    )

    install(FILES ../helics98.hpp DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/helics COMPONENT headers)
endif()

=== networking/gmlc/networking/CMakeLists.txt ===
# ~~~
# Copyright (c) 2017-2021, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~

set(networking_nonasio_source_files addressOperations.cpp interfaceOperations.cpp)

set(networking_asio_source_files
    AsioContextManager.cpp SocketFactory.cpp TcpOperations.cpp TcpConnection.cpp
    TcpServer.cpp TcpAcceptor.cpp
)

set(networking_nonasio_header_files GuardedTypes.hpp addressOperations.hpp
                                    interfaceOperations.hpp
)

set(networking_asio_header_files
    TcpOperations.h
    AsioContextManager.h
    TcpHelperClasses.h
    TcpConnection.h
    TcpServer.h
    TcpAcceptor.h
    Socket.h
    SocketFactory.h
)

if(GMLC_NETWORKING_OBJECT_LIB)
    if(GMLC_NETWORKING_DISABLE_ASIO)
        add_library(
            gmlc_networking_obj OBJECT ${networking_nonasio_source_files}
                                       ${networking_nonasio_header_files}
        )

    else()
        add_library(
            gmlc_networking_obj OBJECT
            ${networking_asio_source_files} ${networking_nonasio_source_files}
            ${networking_asio_header_files} ${networking_nonasio_header_files}
        )
    endif()
    target_include_directories(
        gmlc_networking_obj PUBLIC $<BUILD_INTERFACE:${GMLC_UTILITIES_SOURCE_DIR}>
    )
    target_include_directories(
        gmlc_networking_obj
        PRIVATE $<TARGET_PROPERTY:networking_base,INTERFACE_INCLUDE_DIRECTORIES>
    )

    target_include_directories(
        gmlc_networking_obj SYSTEM
        PRIVATE $<TARGET_PROPERTY:networking_base,INTERFACE_SYSTEM_INCLUDE_DIRECTORIES>
    )

    target_compile_definitions(
        gmlc_networking_obj
        PRIVATE $<TARGET_PROPERTY:networking_base,INTERFACE_COMPILE_DEFINITIONS>
    )
endif()

if(GMLC_NETWORKING_STATIC_LIB)

    if(GMLC_NETWORKING_DISABLE_ASIO)
        add_library(
            gmlc_networking STATIC ${networking_nonasio_source_files}
                                   ${networking_nonasio_header_files}
        )
        target_compile_definitions(
            gmlc_networking PUBLIC "-DGMLC_NETWORKING_DISABLE_ASIO=1"
        )
    else()
        add_library(
            gmlc_networking STATIC
            ${networking_asio_source_files} ${networking_nonasio_source_files}
            ${networking_asio_header_files} ${networking_nonasio_header_files}
        )
    endif()
    target_include_directories(
        gmlc_networking PUBLIC $<BUILD_INTERFACE:${GMLC_NETWORKING_SOURCE_DIR}>
    )

    add_library(gmlc::networking ALIAS gmlc_networking)

    if(GMLC_NETWORKING_ENABLE_ENCRYPTION)
        target_compile_definitions(
            gmlc_networking PUBLIC GMLC_NETWORKING_ENABLE_ENCRYPTION
        )
        target_link_libraries(gmlc_networking PUBLIC OpenSSL::SSL OpenSSL::Crypto)
        if(TARGET OpenSSL::applink)
            target_link_libraries(gmlc_networking PRIVATE OpenSSL::applink)
        endif()
    endif()

    target_link_libraries(gmlc_networking PRIVATE nlohmann_json::nlohmann_json)
    target_link_libraries(gmlc_networking PUBLIC networking_base)
    if(GMLC_NETWORKING_INSTALL)
        install(
            TARGETS gmlc_networking ${GMLC_NETWORKING_LIBRARY_EXPORT_COMMAND}
            RUNTIME DESTINATION bin
            ARCHIVE DESTINATION lib
            LIBRARY DESTINATION lib
        )
        if(GMLC_NETWORKING_DISABLE_ASIO)
            install(FILES ${networking_nonasio_header_files} DESTINATION include)
        else()
            install(FILES ${networking_asio_header_files}
                          ${networking_nonasio_header_files} DESTINATION include
            )
        endif()

        if(GMLC_NETWORKING_CLANG_TIDY)
            set_property(
                TARGET gmlc_networking PROPERTY CXX_CLANG_TIDY "${DO_CLANG_TIDY}"
            )
        endif()
    endif()

endif()

=== PKGBUILD ===
# Maintainer: Philip Top <top1@llnl.gov>

_realname=helics
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.5.2
pkgrel=1
pkgdesc="Hierarchical Engine for Large-scale Infrastructure Co-Simulation (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="https://github.com/GMLC-TDC/HELICS"
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-zeromq"
         "${MINGW_PACKAGE_PREFIX}-fmt")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost")
options=('!strip')
source=("https://github.com/GMLC-TDC/HELICS/releases/download/v${pkgver}/HELICS-v${pkgver}-source.tar.gz")
sha256sums=('c2604694698a1e33c4a68f3d1c5ab0a228ef2bfca1b0d3bae94801dbd3b11048')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_CXX_STANDARD=20 \
    -DBUILD_SHARED_LIBS=ON \
    -DHELICS_ENABLE_IPC_CORE=OFF \
    -DHELICS_DISABLE_GIT_OPERATIONS=ON \
    -DHELICS_DISABLE_VCPKG=ON \
    -DHELICS_DISABLE_ASIO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "OFF" || echo "ON") \
    -DHELICS_USE_EXTERNAL_FMT=ON \
    ${extra_config} \
    ..

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .
  rm -f "${pkgdir}"${MINGW_PREFIX}/bin/libzmq.dll.a
}

=== packaging/mingw-w64-helics/PKGBUILD ===
# Maintainer: Philip Top <top1@llnl.gov>

_realname=helics
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.4.0
pkgrel=1
pkgdesc="Hierarchical Engine for Large-scale Infrastructure Co-Simulation (mingw-w64)"
arch=('any')
url="https://github.com/GMLC-TDC/HELICS"
license=('BSD')
depends=("${MINGW_PACKAGE_PREFIX}-zeromq"
         )
makedepends=("${MINGW_PACKAGE_PREFIX}-gcc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-zeromq"
             "${MINGW_PACKAGE_PREFIX}-boost")
options=('!staticlibs' '!strip')
source=("${_realname}-${pkgver}.tar.gz"::"https://github.com/GMLC-TDC/HELICS/releases/download/v${pkgver}/HELICS-v${pkgver}-source.tar.gz")
sha256sums=('8de39728c7bb03be0bde0d506acc827bea732eddb7bb46892027b777b10dab27')

#prepare() {
#  mkdir -p test
#}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  [[ -d ${srcdir}/build-${MINGW_CHOST} ]] && rm -rf ${srcdir}/build-${MINGW_CHOST}
  mkdir "${srcdir}/build-${MINGW_CHOST}" && cd "${srcdir}/build-${MINGW_CHOST}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"MSYS Makefiles" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DBUILD_SHARED_LIBS=ON \
    -DHELICS_ENABLE_SUBMODULE_UPDATE=OFF\
    ${extra_config} \
    ..

  make
}

package() {
  cd "${srcdir}/build-${MINGW_CHOST}"
  make DESTDIR=${pkgdir} install
}
